
INSERT INTO ESTATS (ESTAT) VALUES ('ESPAA');
INSERT INTO ESTATS (ESTAT) VALUES ('FRANCIA');
INSERT INTO ESTATS (ESTAT) VALUES ('ALEMANIA');

COMMIT;

INSERT INTO PARTITS (PARTITPOL) VALUES ('CDU/CSU');
INSERT INTO PARTITS (PARTITPOL) VALUES ('CONVERGENCIA I UNIO');
INSERT INTO PARTITS (PARTITPOL) VALUES ('DIE LINKE');
INSERT INTO PARTITS (PARTITPOL) VALUES ('ECOLOGISTE');
INSERT INTO PARTITS (PARTITPOL) VALUES ('EH BILDU');
INSERT INTO PARTITS (PARTITPOL) VALUES ('ESQUERRA REPUBLICANA DE CATALUNYA');
INSERT INTO PARTITS (PARTITPOL) VALUES ('INICIATIVA PER CAT VERDS');
INSERT INTO PARTITS (PARTITPOL) VALUES ('PARTIDO NACIONALISTA VASCO');
INSERT INTO PARTITS (PARTITPOL) VALUES ('PARTIDO POPULAR');
INSERT INTO PARTITS (PARTITPOL) VALUES ('PARTIDO SOCIALISTA OBRERO ESPAOL');
INSERT INTO PARTITS (PARTITPOL) VALUES ('PARTIT DELS SOCIALISTES DE CATALUNYA');
INSERT INTO PARTITS (PARTITPOL) VALUES ('PSOE SOCIALISTAS VASCOS');
INSERT INTO PARTITS (PARTITPOL) VALUES ('SOCIALISTE, REPUBLICAIN ET CITOYEN');
INSERT INTO PARTITS (PARTITPOL) VALUES ('SPD');
INSERT INTO PARTITS (PARTITPOL) VALUES ('UNION DES DEMOCRATES ET INDEPENDANTS');
INSERT INTO PARTITS (PARTITPOL) VALUES ('UNION POUR UN MOUVEMENT POPULAIRE');

COMMIT;


INSERT INTO PARLAMENTS (NOMPARLAMENT,NOMBREPARLAMENTARIS,ESTAT,PAISOREGIO,ADRECA,TELEFON,WEB)
VALUES ('PARLAMENT DE CATALUNYA',0,'ESPAA','CATALUNYA','Parc de la Ciutadella, s/n, 08003 Barcelona','933046500','HTTP://www.parlament.cat/');

INSERT INTO PARLAMENTS (NOMPARLAMENT,NOMBREPARLAMENTARIS,ESTAT,PAISOREGIO,ADRECA,TELEFON,WEB)
VALUES ('CONGRESO DE LOS DIPUTADOS',0,'ESPAA','C.A. MADRID','C/Floridablanca s/n - 28071 - MADRID','913906000','http://www.congreso.es/');

INSERT INTO PARLAMENTS (NOMPARLAMENT,NOMBREPARLAMENTARIS,ESTAT,PAISOREGIO,ADRECA,TELEFON,WEB)
VALUES ('PARLAMENTO VASCO',0,'ESPAA','PAIS VASCO','C/Becerro de Bengoa 01005 Vitoria - Gasteiz ','945004000','http://parlamento.euskadi.net/');

INSERT INTO PARLAMENTS (NOMPARLAMENT,NOMBREPARLAMENTARIS,ESTAT,PAISOREGIO,ADRECA,TELEFON,WEB)
VALUES ('ASSEMBLEE NATIONALE',0,'FRANCIA','DEPT. PARIS','126 rue de l-Universit 75355 Paris 07 SP','01 40 63 60 00','http://www.assemblee-nationale.fr');

INSERT INTO PARLAMENTS (NOMPARLAMENT,NOMBREPARLAMENTARIS,ESTAT,PAISOREGIO,ADRECA,TELEFON,WEB)
VALUES ('DEUSTCHER BUNDESTAG',0,'ALEMANIA','BERLIN','Platz der Republik 1-11011 Berlin','49 30 227-0','http://www.bundestag.de/');


COMMIT;


INSERT INTO ESTATDESPESA (CODIESTAT,DESCRIPESTAT) VALUES (1,'PENDENT APROVACIO');
INSERT INTO ESTATDESPESA (CODIESTAT,DESCRIPESTAT) VALUES (2,'APROVADA');
INSERT INTO ESTATDESPESA (CODIESTAT,DESCRIPESTAT) VALUES (3,'PENDENT ABONAMENT');
INSERT INTO ESTATDESPESA (CODIESTAT,DESCRIPESTAT) VALUES (4,'ABONADA');

INSERT INTO FORMAPAGAMENT (CODIFORMAPAG,DESCRIFORMAPAG) VALUES (1, 'TRANSF. BANCARIA PARLAMENT');
INSERT INTO FORMAPAGAMENT (CODIFORMAPAG,DESCRIFORMAPAG) VALUES (2, 'VISA PARLAMENTARI');

INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',1,'Sou mensual');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',2,'Dinar fora del parlament');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',3,'Mobil o tablet');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',4,'Ordinador');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',5,'Transport public');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',6,'Dieta commissio parlamentaria');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',7,'Escorta o xofer parlamentari');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',8,'Lloguer cotxe parlamentari');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENTARI',9,'Altres despeses parlamentari');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENT',1,'Escorta o xofer parlament');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENT',2,'Lloguer cotxe parlament');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENT',3,'Seguretat parlament');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENT',4,'Material oficina parlament');
INSERT INTO TIPUSDESPESA (TIPUSDESPESA,CODICATDESPESA,DESCRIPCIODESPESA) VALUES ('PARLAMENT',5,'Altres despeses parlament');

commit;
