
CREATE OR REPLACE
TRIGGER TRIG_ACTUALITZA_NUMPAR AFTER INSERT OR DELETE ON PARLAMENTARIS 
FOR EACH ROW 
DECLARE
  parlamentaris_actuals NUMBER;
BEGIN

    IF INSERTING THEN
        SELECT NOMBREPARLAMENTARIS INTO parlamentaris_actuals FROM PARLAMENTS
        WHERE PARLAMENTS.NOMPARLAMENT = :NEW.NOMPARLAMENT;
        parlamentaris_actuals := parlamentaris_actuals + 1;
        UPDATE PARLAMENTS SET NOMBREPARLAMENTARIS =parlamentaris_actuals
        WHERE  PARLAMENTS.NOMPARLAMENT = :NEW.NOMPARLAMENT;
    END IF;

    IF DELETING THEN
        SELECT NOMBREPARLAMENTARIS INTO parlamentaris_actuals FROM PARLAMENTS
        WHERE PARLAMENTS.NOMPARLAMENT = :OLD.NOMPARLAMENT;
        parlamentaris_actuals := parlamentaris_actuals - 1;
        UPDATE PARLAMENTS SET NOMBREPARLAMENTARIS =parlamentaris_actuals
        WHERE  PARLAMENTS.NOMPARLAMENT = :OLD.NOMPARLAMENT;
    END IF;

END;
