-- SELECTS EQUIVALENTES A LOS PROC DE CONSULTA

    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO A ******/
    /********************************************/
    
    
Select 
     DESPESES.ID_DESPESA ,
     PARLAMENTARIS.NOM,
     PARLAMENTARIS.COGNOMS,
     DESPESES.DATA_DESPESA,
     DESPESES.IMPORT_DESPESA,
     DESPESES.DESCRIPCIO,
     DESPESES.JUSTIFICACIO,
     DESPESES.NOMPARLAMENT,
     DESPESES.CODIPARLAMENTARI

from DESPESES 

inner join  PARLAMENTARIS on ( 
        DESPESES.CODIPARLAMENTARI=PARLAMENTARIS.CODIPARLAMENTARI and  
        DESPESES.NOMPARLAMENT=PARLAMENTARIS.NOMPARLAMENT)
where 
   DESPESES.NOMPARLAMENT = 'PARLAMENT DE CATALUNYA' 
   and extract(year from DESPESES.DATA_DESPESA)=2009
   and DESPESES.CODIPARLAMENTARI=1  
order by DESPESES.IMPORT_DESPESA desc;
    
    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO B ******/
    /********************************************/
    
select
   DESPESES.CODIPARLAMENTARI,
   PARLAMENTARIS.NOM,
   PARLAMENTARIS.COGNOMS,
   PARLAMENTARIS.PARTITPOL,
   extract(year from DESPESES.DATA_DESPESA) as AO,
   SUM (DESPESES.IMPORT_DESPESA) as total
from PARLAMENTARIS   
   inner join DESPESES on (DESPESES.CODIPARLAMENTARI=PARLAMENTARIS.CODIPARLAMENTARI 
      and DESPESES.NOMPARLAMENT=PARLAMENTARIS.NOMPARLAMENT)
where  
   extract(year from DESPESES.DATA_DESPESA)=2011 
   and DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG'

  group by DESPESES.CODIPARLAMENTARI, 
           PARLAMENTARIS.NOM, 
           PARLAMENTARIS.COGNOMS,
           PARLAMENTARIS.PARTITPOL, 
           extract(year from DESPESES.DATA_DESPESA)
ORDER BY   SUM (DESPESES.IMPORT_DESPESA) DESC;

    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO C ******/
    /********************************************/
    
   select
      PARLAMENTS.NOMPARLAMENT as PARLAMENT,
     --NUMERO DE PARLAMENTARIOS CON GASTO
     ( SELECT COUNT (*)  FROM(
      select  NOMPAR, CODIPAR 
      from 
      ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, 
                         DESPESES2.CODIPARLAMENTARI as CODIPAR 
             from DESPESES DESPESES2 where 
             extract (year from DESPESES2.DATA_DESPESA)=2012
             and DESPESES2.TIPUSDESPESA='PARLAMENTARI'), PARLAMENTS
      where NOMPAR=PARLAMENTS.NOMPARLAMENT  
      )
      WHERE PARLAMENTS.NOMPARLAMENT=NOMPAR )AS nombreparlamentaris,
   
      -- MEDIA DEL GASTO DE LOS PARLAMENTARIOS                                                 
      Round  ((SELECT SUM (DESPESES.IMPORT_DESPESA) 
                     from DESPESES 
                     WHERE PARLAMENTS.nomparlament=DESPESES.nomparlament AND   
                           DESPESES.TIPUSDESPESA='PARLAMENTARI'  and 
                           ( extract(year from DESPESES.DATA_DESPESA)=2012)
                           )/( 
                           select COUNT (*)  
                              FROM(
                                 select  NOMPAR, CODIPAR 
                                 from 
                                 ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, 
                                                    DESPESES2.CODIPARLAMENTARI as CODIPAR 
                                        from DESPESES DESPESES2 where 
                                        extract (year from DESPESES2.DATA_DESPESA)=2012
                                        and DESPESES2.TIPUSDESPESA='PARLAMENTARI'), PARLAMENTS
                                 where NOMPAR=PARLAMENTS.NOMPARLAMENT )
                             where PARLAMENTS.NOMPARLAMENT=NOMPAR ) 
                 ,2) AS MITJA_PARLAMENTARI,                                               
                                                       
      -- GASTO SOLO DE LOSPARLAMENTARIOS
      (SELECT SUM (DESPESES.IMPORT_DESPESA) 
             from DESPESES 
             WHERE PARLAMENTS.nomparlament=DESPESES.nomparlament AND   
             DESPESES.TIPUSDESPESA='PARLAMENTARI'  AND 
             ( extract(year from DESPESES.DATA_DESPESA)=2012)) as NOMES_PARLAMENTARI,
             
      -- GASTO SOLO DE LOS PARLAMENTOS       
     (SELECT SUM (DESPESES.IMPORT_DESPESA) 
             from DESPESES  
             WHERE PARLAMENTS.nomparlament=DESPESES.nomparlament AND   
             DESPESES.TIPUSDESPESA='PARLAMENT'    AND 
             ( exTRACT(YEAR FROM DESPESES.DATA_DESPESA)=2012) ) AS NOMES_PARLAMENT,
   
     -- GASTO TOTAL   
     (SELECT SUM (DESPESES.IMPORT_DESPESA) 
             from DESPESES  
             WHERE PARLAMENTS.nomparlament=DESPESES.nomparlament AND   
             ( exTRACT(YEAR FROM DESPESES.DATA_DESPESA)=2012) ) AS DESPESA_TOTAL
             
   from PARLAMENTS PARLAMENTS
   group by    PARLAMENTS.NOMPARLAMENT , PARLAMENTS.NOMBREPARLAMENTARIS;

    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO D ******/
    /********************************************/
    
    
    SELECT
       TIPUSDESPESA.CODICATDESPESA,
       TIPUSDESPESA.DESCRIPCIODESPESA,
       SUM (DESPESES.IMPORT_DESPESA)
    from TIPUSDESPESA
      INNER JOIN DESPESES ON DESPESES.CODICATDESPESA=TIPUSDESPESA.CODICATDESPESA and DESPESES.TIPUSDESPESA=TIPUSDESPESA.TIPUSDESPESA
    
    WHERE  (EXTRACT(YEAR FROM DESPESES.DATA_DESPESA)=2013 ) and DESPESES.NOMPARLAMENT='ASSEMBLEE NATIONALE'
    group by    TIPUSDESPESA.CODICATDESPESA,   TIPUSDESPESA.DESCRIPCIODESPESA;
        
    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO E ******/
    /********************************************/
    

SELECT
     DESPESES.NOMPARLAMENT,
     DESPESES.CODIPARLAMENTARI,
     PARLAMENTARIS.PARTITPOL,
     PARLAMENTARIS.NOM,
     PARLAMENTARIS.COGNOMS,
     
     --***********************************************************************************     
     -- Suma de los gastos del parlamento asociados a parlamentarios, en el ao contemplado
     --***********************************************************************************     
     (SELECT SUM (DESPESES.IMPORT_DESPESA)
     FROM DESPESES 
           WHERE DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
           DESPESES.TIPUSDESPESA='PARLAMENTARI' AND
           EXTRACT (YEAR FROM DATA_DESPESA)=2012
     GROUP BY DESPESES.NOMPARLAMENT) AS SUMA_TOTAL_PARLAMENT,
     
     --***********************************************************************************      
     -- Suma de los gastos PROPIOS DE CADA PARLAMENTARIO, en el ao contemplado
     --***********************************************************************************      
     (SELECT SUM (DESPESES2.IMPORT_DESPESA)
     FROM DESPESES DESPESES2
           WHERE DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
           DESPESES2.TIPUSDESPESA='PARLAMENTARI' AND
           DESPESES2.NOMPARLAMENT=DESPESES.NOMPARLAMENT AND
           DESPESES2.CODIPARLAMENTARI=DESPESES.CODIPARLAMENTARI AND
           EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 
     GROUP BY DESPESES2.NOMPARLAMENT, DESPESES2.CODIPARLAMENTARI) AS SUMA_PARLAMENTARI,
     
     --***********************************************************************************
     -- Numero de parlamentarios con gastos asociados para el parlamento y ao contemplados
     --***********************************************************************************     
    (SELECT COUNT (*)  FROM -- Este fragmento me cuenta las filas devueltas por la select mas interna
        (
        select  CODIPAR 
            FROM 
            -- Este fragmento me devuelve tantas filas como parlamentarios con gasto para el parlamento y ao contemplados
            ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, DESPESES2.CODIPARLAMENTARI as CODIPAR 
                   FROM DESPESES DESPESES2 WHERE 
                   EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 AND
                   DESPESES2.TIPUSDESPESA='PARLAMENTARI' and
                   DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG'
                   )
     )) AS NumParlamAmbDespesa,
        
     --***********************************************************************************
     -- Media del gasto por parlamentario, para ese parlamento y ao, teniendo en cuenta 
     -- SOLAMENTE los parlamentarios que tienen registrado algun gasto
     --***********************************************************************************     
     ROUND ( 
     ( 
       (      -- Suma de los gastos del parlamento asociados a parlamentarios, en el ao contemplado
         SELECT SUM (DESPESES.IMPORT_DESPESA)
         FROM DESPESES 
               WHERE DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
               DESPESES.TIPUSDESPESA='PARLAMENTARI' AND
               EXTRACT (YEAR FROM DATA_DESPESA)=2012
         GROUP BY DESPESES.NOMPARLAMENT
        )/(   -- Numero de parlamentarios con gastos asociados para el parlamento y ao contemplados
      SELECT COUNT (*)  FROM(
          select  CODIPAR 
              from 
              ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, 
                                 DESPESES2.CODIPARLAMENTARI as CODIPAR 
                     FROM DESPESES DESPESES2 WHERE 
                     extract (year from DESPESES2.DATA_DESPESA)=2012
                     AND DESPESES2.TIPUSDESPESA='PARLAMENTARI')
          WHERE NOMPAR='DEUSTCHER BUNDESTAG')) 
      ),2) AS MITJA_parlamentaris,
    
     --***********************************************************************************
     -- PORCENTAJE EN EL QUE LOS GASTOS DE ESE PARLAMENTARIO, SUPERAN LA MEDIA 
     -- Se calcula como:
     -- ( Gastos de ese perlamentario * 100 / Media del gasto )- 100
     --***********************************************************************************     
      Round(
          --***********************************************************************************      
          -- Suma de los gastos PROPIOS DE CADA PARLAMENTARIO, en el ao contemplado
          --*********************************************************************************** 
        (SELECT SUM (DESPESES2.IMPORT_DESPESA)
        FROM DESPESES DESPESES2
              WHERE DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
              DESPESES2.TIPUSDESPESA='PARLAMENTARI' AND
              DESPESES2.NOMPARLAMENT=DESPESES.NOMPARLAMENT AND
              DESPESES2.CODIPARLAMENTARI=DESPESES.CODIPARLAMENTARI AND
              EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 
        GROUP BY DESPESES2.NOMPARLAMENT, DESPESES2.CODIPARLAMENTARI) *100/( 
           --***********************************************************************************
           -- Media del gasto por parlamentario, para ese parlamento y ao, teniendo en cuenta 
           -- SOLAMENTE los parlamentarios que tienen registrado algun gasto
           --***********************************************************************************    
        (       -- Suma de los gastos del parlamento asociados a parlamentarios, en el ao contemplado
          SELECT SUM (DESPESES.IMPORT_DESPESA)
          FROM DESPESES 
                WHERE DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
                DESPESES.TIPUSDESPESA='PARLAMENTARI' AND
                EXTRACT (YEAR FROM DATA_DESPESA)=2012
          GROUP BY DESPESES.NOMPARLAMENT
         )/(
         SELECT COUNT (*)  FROM 
             (    -- Este fragmento me cuenta las filas devueltas por la select mas interna
             select  CODIPAR 
                 FROM 
                 -- Este fragmento me devuelve tantas filas como parlamentarios con gasto para el parlamento y ao contemplados
                 ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, DESPESES2.CODIPARLAMENTARI as CODIPAR 
                        FROM DESPESES DESPESES2 WHERE 
                        EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 AND
                        DESPESES2.TIPUSDESPESA='PARLAMENTARI' and
                        DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG'
                  )
             )  
          ) 
         )
       ,2) -100 AS PERCET_SUPERA

    from DESPESES
    
    -- Join para ir a buscar el nombre y apellidos del parlamentario
    INNER JOIN  PARLAMENTARIS  ON ( DESPESES.CODIPARLAMENTARI=PARLAMENTARIS.CODIPARLAMENTARI AND  DESPESES.NOMPARLAMENT=PARLAMENTARIS.NOMPARLAMENT)
    
    WHERE 
       EXTRACT(YEAR FROM DESPESES.DATA_DESPESA)=2012 AND DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG'
       GROUP BY      DESPESES.NOMPARLAMENT,
                     DESPESES.CODIPARLAMENTARI,
                     PARLAMENTARIS.PARTITPOL,
                     --PARLAMENTS.NOMBREPARLAMENTARIS, 
                     PARLAMENTARIS.NOM, 
                     PARLAMENTARIS.COGNOMS
    
    HAVING 
     --***********************************************************************************
     -- RESTRICCION DE LOS RESULTADOS DEVUELTOS: Solo devolvemos
     -- los parlamentarios CUYO GASTO ha sido MAYOR QUE la media de ese parlamento para ese ao
     --***********************************************************************************
     
          --***********************************************************************************      
          -- Suma de los gastos PROPIOS DE CADA PARLAMENTARIO, en el ao contemplado
          --*********************************************************************************** 
         (SELECT SUM (DESPESES2.IMPORT_DESPESA)
         FROM DESPESES DESPESES2
               WHERE DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
               DESPESES2.TIPUSDESPESA='PARLAMENTARI' AND
               DESPESES2.NOMPARLAMENT=DESPESES.NOMPARLAMENT AND
               DESPESES2.CODIPARLAMENTARI=DESPESES.CODIPARLAMENTARI AND
               EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 
         GROUP BY DESPESES2.NOMPARLAMENT, DESPESES2.CODIPARLAMENTARI) 
         >
         --***********************************************************************************
         -- Media del gasto por parlamentario, para ese parlamento y ao, teniendo en cuenta 
         -- SOLAMENTE los parlamentarios que tienen registrado algun gasto
         --***********************************************************************************   
         ROUND ( 
         ( 
         (       -- Suma de los gastos del parlamento asociados a parlamentarios, en el ao contemplado
           SELECT SUM (DESPESES.IMPORT_DESPESA)
           FROM DESPESES 
                 WHERE DESPESES.NOMPARLAMENT='DEUSTCHER BUNDESTAG' AND 
                 DESPESES.TIPUSDESPESA='PARLAMENTARI' AND
                 EXTRACT (YEAR FROM DATA_DESPESA)=2012
           GROUP BY DESPESES.NOMPARLAMENT
          )/(  -- Numero de parlamentarios con gastos asociados para el parlamento y ao contemplados
          SELECT COUNT (*)  FROM 
              (    -- Este fragmento me cuenta las filas devueltas por la select mas interna
              select  CODIPAR 
                  FROM 
                  -- Este fragmento me devuelve tantas filas como parlamentarios con gasto para el parlamento y ao contemplados
                  ( select distinct DESPESES2.NOMPARLAMENT as NOMPAR, DESPESES2.CODIPARLAMENTARI as CODIPAR 
                         FROM DESPESES DESPESES2 WHERE 
                         EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2012 AND
                         DESPESES2.TIPUSDESPESA='PARLAMENTARI' and
                         DESPESES2.NOMPARLAMENT='DEUSTCHER BUNDESTAG'
                   )
              )  
           ) 
          ),2);


        
    /********************************************/
    /****** PRUEBA PARA EL PROCEDIMIENTO F ******/
    /********************************************/
    
    
      
    SELECT 
       NOMPARLAMENT,
       NOMBREPARLAMENTARIS,
       sum(PENDENT_APROVACIO),
       sum(APROVADA), 
       sum (PENDENT_ABONAMENT),
       sum (ABONADA) from 
    (
    SELECT
       PARLAMENTS.NOMPARLAMENT,
       PARLAMENTS.NOMBREPARLAMENTARIS ,
    
       ESTATDESPESA.DESCRIPESTAT,
       -- SUM (DESPESAS.IMPORT_DESPESA)   as SUMA_DESPESA
       SUM  ( case when  ESTATDESPESA.CODIESTAT=1 THEN (DESPESES.IMPORT_DESPESA) ELSE 0 END) as PENDENT_APROVACIO,
       SUM  ( case when  ESTATDESPESA.CODIESTAT=2 THEN (DESPESES.IMPORT_DESPESA) ELSE 0 END) as APROVADA,
       SUM  ( case when  ESTATDESPESA.CODIESTAT=3 THEN (DESPESES.IMPORT_DESPESA) ELSE 0 END) as PENDENT_ABONAMENT,
       SUM  ( CASE WHEN  ESTATDESPESA.CODIESTAT=4 THEN (DESPESES.IMPORT_DESPESA) ELSE 0 END) AS ABONADA 
    from DESPESES 
      INNER JOIN ESTATDESPESA ON DESPESES.CODIESTAT=ESTATDESPESA.CODIESTAT
      INNER JOIN PARLAMENTS ON  DESPESES.NOMPARLAMENT=PARLAMENTS.NOMPARLAMENT 
    WHERE  EXTRACT(YEAR FROM DESPESES.DATA_DESPESA)=2013 or ( DESPESES.DATA_DESPESA is null )
    GROUP BY   PARLAMENTS.NOMPARLAMENT , PARLAMENTS.NOMBREPARLAMENTARIS, ESTATDESPESA.DESCRIPESTAT
    
    )
    group by  NOMPARLAMENT,NOMBREPARLAMENTARIS ;
