SET SERVEROUTPUT ON SIZE UNLIMITED     
SET DEFINE OFF


DECLARE 
  RSP    CLOB;
  DESP_CREADA  DESPESES.ID_DESPESA%TYPE;
  
BEGIN

    -- ***********************
    -- ***********************
    -- PRUEBAS ABM PARLAMENTOS
    -- ***********************
    -- ***********************

    -- ALTA PARLAMENTO
    A_PARLAMENT ('PARLAMENTO ANDALUZ','ESPAA','ANDALUCccIA','c\ San Juan de Ribera, s/n 41009 Sevilla.','933046500','HTTP://www.parlamentodeandalucia.es/',RSP);  
    ULTIMA_LINEA_LOG;

    -- MODIFICACION PARLAMENTO
    M_PARLAMENT ('PARLAMENTO ANDALUZ','ANDALUCIA','c\ San Juan de Ribera, s/n 41009 Sevilla.','933046500','HTTP://www.parlamentodeandalucia.es/',RSP);
    ULTIMA_LINEA_LOG;
    
    -- BAJA PARLAMENT
    B_PARLAMENT ('PARLAMENTO ANDALUZ',RSP);
    ULTIMA_LINEA_LOG; 
    
    
    -- ALTA ERRONEA PARLAMENTO - PARLAMENTO EXISTENTE
    A_PARLAMENT ('PARLAMENT DE CATALUNYA','ESPAA','CATALUNYA','Parc de la Ciutadella, s/n, 08003 Barcelona','933046500','HTTP://www.parlament.cat/',RSP);
    ULTIMA_LINEA_LOG;
    
    -- ALTA ERRONEA PARLAMENTO - PARLAMENTO NULO
    A_PARLAMENT ('','FRANCIA','CATALUNYA','Parc de la Ciutadella, s/n, 08003 Barcelona','933046500','HTTP://www.parlament.cat/',RSP);
    ULTIMA_LINEA_LOG;
    
    -- ALTA ERRONEA PARLAMENTO - ESTADO INEXISTENTE
    A_PARLAMENT ('PARLAMENTO ITALIANO','ITALIA','','---','---','---',RSP);
    ULTIMA_LINEA_LOG; 
    
    -- ALTA ERRONEA PARLAMENTO - DIRECCION NULA
    A_PARLAMENT ('PARLAMENTO ANDALUZ','ESPAA','ANDALUCIA','','933046500','HTTP://www.parlamentodeandalucia.es/',RSP);
    ULTIMA_LINEA_LOG; 
    
    -- ALTA ERRONEA PARLAMENTO - TELEFONO NULO
    A_PARLAMENT ('PARLAMENTO ANDALUZ','ESPAA','ANDALUCIA','--','','HTTP://www.parlamentodeandalucia.es/',RSP); 
    ULTIMA_LINEA_LOG;   
    
    -- BAJA ERRONEA PARLAMENTO - PARLAMENTO NO EXISTE
    B_PARLAMENT ('PARLAMENTO ANDALUZ',RSP); 
    ULTIMA_LINEA_LOG;
    
    -- BAJA ERRONEA PARLAMENTO - TIENE PARLAMENTARIOS EN ACTIVO
    B_PARLAMENT ('CONGRESO DE LOS DIPUTADOS',RSP);
    ULTIMA_LINEA_LOG; 
    
    -- MODIFICACION ERRONEA PARLAMENTO - PARLAMENTO NO EXISTE
    M_PARLAMENT ('PARLAMENTO ANDALUZ','ANDALUCIA','c\ San Juan de Ribera, s/n 41009 Sevilla.','933046500','HTTP://www.parlamentodeandalucia.es/',RSP);  
    ULTIMA_LINEA_LOG;
    
    -- MODIFICACION ERRONEA PARLAMENTO - DIRECCION NULA   
    M_PARLAMENT ('CONGRESO DE LOS DIPUTADOS','ESPAA','','9145587458','http://www.congreso.es/',RSP);
    ULTIMA_LINEA_LOG;
    
    -- MODIFICACION ERRONEA PARLAMENTO - TELEFONO NULO
    M_PARLAMENT ('CONGRESO DE LOS DIPUTADOS','ESPAA','C/Floridablanca s/n - 28071 - MADRID','','HTTP://www.parlamentodeandalucia.es/',RSP);  
    ULTIMA_LINEA_LOG;
    
    
     -- ****************************
     -- ****************************
     -- PRUEBAS ABM PARLAMENTARIOS
     -- ****************************
     -- ****************************
     
     
    -- ALTA CORRECTA PARLAMENTARIO
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','19084893E','Pedro','Perez','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;
    
    -- MODIFICACION CORRECTA PARLAMENTARIO
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','19084893E','JUAN LOPEZ','Perez','PARTIDO POPULAR',RSP);    
    ULTIMA_LINEA_LOG;     
    
    -- BORRADO CORRECTO PARLAMENTARIO
    B_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14',RSP);
    ULTIMA_LINEA_LOG;

    -- ALTA ERRONEA PARLAMENTARIO-PARLAMENTO INVALIDO
    A_PARLAMENTARI('PARLAMENTO GALLEGO','14','19084893E','Pedro','Perez','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;
    
    -- ALTA  ERRONEA PARLAMENTARIO- CODIGO PARLAMENTARIO INVALIDO
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','10','19084893E','Pedro','Perez','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;
    
    -- ALTA  ERRONEA PARLAMEMTARIO- PARTIDO POLITICO INVALID
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','19084893E','Pedro','Perez','PARTIDO DE LOS POBRES',RSP);
    ULTIMA_LINEA_LOG;
    
    -- ALTA  ERRONEA PARLAMEMTARIO- NIF NULO
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','','Pedro','Perez','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;

    -- ALTA  ERRONEA PARLAMEMTARIO- NOMBRE NULO  
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','19084893E','','Perez','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;
        
    -- ALTA  ERRONEA PARLAMEMTARIO- APELLIDOS NULOS        
    A_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','19084893E','Pedro','','PARTIDO POPULAR',RSP);
    ULTIMA_LINEA_LOG;
    
    -- BAJA  ERRONEA PARLAMEMTARIO- PARLAMENTARIO NULO
    B_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','',RSP);
    ULTIMA_LINEA_LOG;
    
    -- BAJA  ERRONEA PARLAMEMTARIO- PARLAMENTARIO CON GASTOS    
    B_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','1',RSP);
    ULTIMA_LINEA_LOG;
        
    -- MODIFICACION ERRONEA PARLAMENTARIO-PARLAMENTARIO INVALIDO
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','14','AAAAA','JUAN LOPEZ','Perez','PARTIDO POPULAR',RSP);    
    ULTIMA_LINEA_LOG;     
    
    -- MODIFICACION  ERRONEA PARLAMEMTARIO- PARTIDO POLITICO INVALID
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','1','19084893E','JUAN LOPEZ','Perez','PARTIDO  DE LOS POBRES',RSP);    
    ULTIMA_LINEA_LOG;     
    
    -- MODIFICACION  ERRONEA PARLAMEMTARIO- NIF NULO
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','1','','JUAN LOPEZ','Perez','PARTIDO POPULAR',RSP);    
    ULTIMA_LINEA_LOG;     
    
    -- MODIFICACION  ERRONEA PARLAMEMTARIO- NOMBRE NULO    
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','1','19084893E','','Perez','PARTIDO POPULAR',RSP);    
    ULTIMA_LINEA_LOG;     
    
    -- MODIFICACION  ERRONEA PARLAMEMTARIO- APELLIDOS NULOS       
    M_PARLAMENTARI('CONGRESO DE LOS DIPUTADOS','1','19084893E','JUAN LOPEZ','','PARTIDO POPULAR',RSP);    
    ULTIMA_LINEA_LOG;     
       
    -- ****************************
    -- ****************************
    -- PRUEBAS ABM GASTOS
    -- ****************************
    -- ****************************

    -- ALTA CORRECTA GASTO
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- MODIFICACION CORRECTA ULTIMO GASTO CREADO
    DESP_CREADA:=SEQ_ID_DESPESA.CURRVAL; 
    M_DESPESA (DESP_CREADA,65250,20,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',1,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- BORRADO CORRECTO GASTO
    B_DESPESA (DESP_CREADA, RSP);  
    ULTIMA_LINEA_LOG;   
    
    -- ALTA  ERRONEA GASTO- PARLAMENTO INVALIDO
    A_DESPESA ('01/12/2013','PARLAMENTO ANZALUZ',9,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- TIPUS DE DESPESA INVALIDO
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'CAP',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- PARLAMENTARIO INVALIDO
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',50,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- CODIGO CAT GASTO INVALIDO
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',50,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- IMPORTE DE GASTO INVALIDO   
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,'',NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- DESCRIPCION NO INFORMADA
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,65250,NULL,'','','Segons contracte','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   
    
    -- ALTA  ERRONEA GASTO- JUSTIFICACION NO INFORMADA
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','','http://www.despesesparlaments.info/',4,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- CODIGO DE ESTADO DEL GASTO INVALIDO   
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',50,1,RSP);    
    ULTIMA_LINEA_LOG;   

    -- ALTA  ERRONEA GASTO- CODIGO DE LA FORMA DE PAGO INVALIDA
    A_DESPESA ('01/12/2013','PARLAMENTO VASCO',9,'PARLAMENTARI',1,65250,NULL,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',4,5,RSP);    
    ULTIMA_LINEA_LOG;   
    
    -- BAJA  ERRONEA GASTO- GASTO INEXISTENTE
    B_DESPESA (100000, RSP);  
    ULTIMA_LINEA_LOG;   
        
    -- MODIFICACION ERRONEA GASTO - GASTO INEXISTENTE
    M_DESPESA (100000,65250,20,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',1,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- MODIFICACION ERRONEA GASTO - IMPORTE DE GASTO INVALIDO 
    M_DESPESA (100,'',20,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',1,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- MODIFICACION ERRONEA GASTO - DESCRIPCION NO INFORMADA
    M_DESPESA (100,65250,20,'','','Segons contracte','http://www.despesesparlaments.info/',1,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- MODIFICACION ERRONEA GASTO - JUSTIFICACION NO INFORMADA  
    M_DESPESA (100,65250,20,'','Sou mensual','','http://www.despesesparlaments.info/',1,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- MODIFICACION ERRONEA GASTO - CODIGO DE ESTADO DEL GASTO INVALIDO       
    M_DESPESA (100,65250,20,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',50,1,RSP);   
    ULTIMA_LINEA_LOG;   
    
    -- MODIFICACION ERRONEA GASTO - CODIGO DE LA FORMA DE PAGO INVALIDA   
    M_DESPESA (100,65250,20,'','Sou mensual','Segons contracte','http://www.despesesparlaments.info/',1,10,RSP);   
    ULTIMA_LINEA_LOG;   
    
END;

